#include <iostream>
#include <conio.h>
using namespace std;

#include "thread.h"

class MyThread : public Thread {
  private: 
		Synchronize *lock;
		Monitor *monitor;
	protected:
		void run(void *args) {
			for (int i=0;i<10;i++) {
		    lock->lock();
				cout << "thread " << tid() << " .... " << i << endl;
				lock->unlock();
				if (tid() == 3) {
					if (i==6) monitor->notify();
					if (i==8) monitor->notify();
				}
				else {
					if (i==3) monitor->wait();
				}
				delay(500);
			}
		}
	public:
		MyThread (Synchronize& lock, Monitor& monitor) : Thread() {
			this->lock = &lock; 
			this->monitor = &monitor;
		};
};

int main () {
  Synchronize lock;
  Monitor monitor;
	MyThread a(lock,monitor),b(lock,monitor),c(lock,monitor);
	getch();
}
