#include <iostream>
//#include <conio.h>
using namespace std;

#include "thread.h"
#include "timer.h"

static Synchronize *s = new Synchronize();

class MyThread : public Thread {
	private:
		Timer *t;
	protected:
		void run(void *args) {
			int i = 0;
			Monitor monitor;
			Proxy proxy(monitor);
			Timer timer(proxy);
			t = &timer;
			timer.start(1000,1000,1000);
			for (;;) {
				Proxy *p = Proxy::receive(monitor); 
				if (*p == proxy) {
					s->lock();
					struct timespec t;
					Timer::get_time(&t);
					cout << "tick " << tid() << " .... " << ++i << " " << t.tv_sec << ":" << t.tv_nsec << endl;
					s->unlock();
				}
			}
		}
	public:
		MyThread () /*: Thread()*/ {};
		void stop() {
			cout << "stopped " << tid() << endl;
			t->stop();
		}
};

int main () {
        cout << "zaciatok trapenia\n";
	//MyThread *a1 = new MyThread();
	//MyThread *a2 = new MyThread();
	//MyThread *a3 = new MyThread();
        int num_thread = 100;
        MyThread* mythread[num_thread];
        for (int i = 0; i < num_thread; i++){
            mythread[i] = new MyThread();
        }
        for(int i = 0; i < num_thread; i++){
            mythread[i]->join();
        }

        //a1->join();
        //a2->join();
        //a3->join();
	//getch();
	//a3->stop();
	//getch();
	//a1->stop();
	//getch();
	//a2->stop();
	//getch();
}
